diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-includes/class-wp-xmlrpc-server.php ./wordpress-3.4/wp-includes/class-wp-xmlrpc-server.php
*** ./wordpress-3.3.2/wp-includes/class-wp-xmlrpc-server.php	2011-10-27 13:36:49.000000000 -0500
--- ./wordpress-3.4/wp-includes/class-wp-xmlrpc-server.php	2012-06-05 11:25:05.000000000 -0500
***************
*** 461,540 ****
  			return $this->error;
  		}
  
  		if ( !current_user_can( 'edit_page', $page_id ) )
  			return new IXR_Error( 401, __( 'Sorry, you cannot edit this page.' ) );
  
  		do_action('xmlrpc_call', 'wp.getPage');
  
- 		// Lookup page info.
- 		$page = get_page($page_id);
- 
  		// If we found the page then format the data.
  		if ( $page->ID && ($page->post_type == 'page') ) {
! 			// Get all of the page content and link.
! 			$full_page = get_extended($page->post_content);
! 			$link = post_permalink($page->ID);
! 
! 			// Get info the page parent if there is one.
! 			$parent_title = "";
! 			if ( !empty($page->post_parent) ) {
! 				$parent = get_page($page->post_parent);
! 				$parent_title = $parent->post_title;
! 			}
! 
! 			// Determine comment and ping settings.
! 			$allow_comments = comments_open($page->ID) ? 1 : 0;
! 			$allow_pings = pings_open($page->ID) ? 1 : 0;
! 
! 			// Format page date.
! 			$page_date = mysql2date('Ymd\TH:i:s', $page->post_date, false);
! 			$page_date_gmt = mysql2date('Ymd\TH:i:s', $page->post_date_gmt, false);
! 
! 			// For drafts use the GMT version of the date
! 			if ( $page->post_status == 'draft' )
! 				$page_date_gmt = get_gmt_from_date( mysql2date( 'Y-m-d H:i:s', $page->post_date ), 'Ymd\TH:i:s' );
! 
! 			// Pull the categories info together.
! 			$categories = array();
! 			foreach ( wp_get_post_categories($page->ID) as $cat_id ) {
! 				$categories[] = get_cat_name($cat_id);
! 			}
! 
! 			// Get the author info.
! 			$author = get_userdata($page->post_author);
! 
! 			$page_template = get_post_meta( $page->ID, '_wp_page_template', true );
! 			if ( empty( $page_template ) )
! 				$page_template = 'default';
! 
! 			$page_struct = array(
! 				'dateCreated'			=> new IXR_Date($page_date),
! 				'userid'				=> $page->post_author,
! 				'page_id'				=> $page->ID,
! 				'page_status'			=> $page->post_status,
! 				'description'			=> $full_page['main'],
! 				'title'					=> $page->post_title,
! 				'link'					=> $link,
! 				'permaLink'				=> $link,
! 				'categories'			=> $categories,
! 				'excerpt'				=> $page->post_excerpt,
! 				'text_more'				=> $full_page['extended'],
! 				'mt_allow_comments'		=> $allow_comments,
! 				'mt_allow_pings'		=> $allow_pings,
! 				'wp_slug'				=> $page->post_name,
! 				'wp_password'			=> $page->post_password,
! 				'wp_author'				=> $author->display_name,
! 				'wp_page_parent_id'		=> $page->post_parent,
! 				'wp_page_parent_title'	=> $parent_title,
! 				'wp_page_order'			=> $page->menu_order,
! 				'wp_author_id'			=> (string) $author->ID,
! 				'wp_author_display_name'	=> $author->display_name,
! 				'date_created_gmt'		=> new IXR_Date($page_date_gmt),
! 				'custom_fields'			=> $this->get_custom_fields($page_id),
! 				'wp_page_template'		=> $page_template
! 			);
! 
! 			return($page_struct);
  		}
  		// If the page doesn't exist indicate that.
  		else {
--- 1935,1952 ----
  			return $this->error;
  		}
  
+ 		$page = get_page($page_id);
+ 		if ( ! $page )
+ 			return new IXR_Error( 404, __( 'Invalid post ID.' ) );
+ 
  		if ( !current_user_can( 'edit_page', $page_id ) )
  			return new IXR_Error( 401, __( 'Sorry, you cannot edit this page.' ) );
  
  		do_action('xmlrpc_call', 'wp.getPage');
  
  		// If we found the page then format the data.
  		if ( $page->ID && ($page->post_type == 'page') ) {
! 			return $this->_prepare_page( $page );
  		}
  		// If the page doesn't exist indicate that.
  		else {
***************
*** 577,587 ****
  		if ( $num_pages >= 1 ) {
  			$pages_struct = array();
  
! 			for ( $i = 0; $i < $num_pages; $i++ ) {
! 				$page = wp_xmlrpc_server::wp_getPage(array(
! 					$blog_id, $pages[$i]->ID, $username, $password
! 				));
! 				$pages_struct[] = $page;
  			}
  
  			return($pages_struct);
--- 1989,1997 ----
  		if ( $num_pages >= 1 ) {
  			$pages_struct = array();
  
! 			foreach ($pages as $page) {
! 				if ( current_user_can( 'edit_page', $page->ID ) )
! 					$pages_struct[] = $this->_prepare_page( $page );
  			}
  
  			return($pages_struct);
***************
*** 612,621 ****
  
  		do_action('xmlrpc_call', 'wp.newPage');
  
- 		// Make sure the user is allowed to add new pages.
- 		if ( !current_user_can('publish_pages') )
- 			return(new IXR_Error(401, __('Sorry, you cannot add new pages.')));
- 
  		// Mark this as content for a page.
  		$args[3]["post_type"] = 'page';
  
--- 2022,2027 ----
***************
*** 659,664 ****
--- 2065,2072 ----
  		if ( !$result )
  			return(new IXR_Error(500, __('Failed to delete the page.')));
  
+ 		do_action( 'xmlrpc_call_success_wp_deletePage', $page_id, $args );
+ 
  		return(true);
  	}
  
***************
*** 750,766 ****
  		// The date needs to be formatted properly.
  		$num_pages = count($page_list);
  		for ( $i = 0; $i < $num_pages; $i++ ) {
! 			$post_date = mysql2date('Ymd\TH:i:s', $page_list[$i]->post_date, false);
! 			$post_date_gmt = mysql2date('Ymd\TH:i:s', $page_list[$i]->post_date_gmt, false);
! 
! 			$page_list[$i]->dateCreated = new IXR_Date($post_date);
! 			$page_list[$i]->date_created_gmt = new IXR_Date($post_date_gmt);
! 
! 			// For drafts use the GMT version of the date
! 			if ( $page_list[$i]->post_status == 'draft' ) {
! 				$page_list[$i]->date_created_gmt = get_gmt_from_date( mysql2date( 'Y-m-d H:i:s', $page_list[$i]->post_date ), 'Ymd\TH:i:s' );
! 				$page_list[$i]->date_created_gmt = new IXR_Date( $page_list[$i]->date_created_gmt );
! 			}
  
  			unset($page_list[$i]->post_date_gmt);
  			unset($page_list[$i]->post_date);
--- 2158,2165 ----
  		// The date needs to be formatted properly.
  		$num_pages = count($page_list);
  		for ( $i = 0; $i < $num_pages; $i++ ) {
! 			$page_list[$i]->dateCreated = $this->_convert_date(  $page_list[$i]->post_date );
! 			$page_list[$i]->date_created_gmt = $this->_convert_date_gmt( $page_list[$i]->post_date_gmt, $page_list[$i]->post_date );
  
  			unset($page_list[$i]->post_date_gmt);
  			unset($page_list[$i]->post_date);
***************
*** 809,815 ****
  	/**
  	 * Get list of all tags
  	 *
! 	 * @since 2.7
  	 *
  	 * @param array $args Method parameters.
  	 * @return array
--- 2208,2214 ----
  	/**
  	 * Get list of all tags
  	 *
! 	 * @since 2.7.0
  	 *
  	 * @param array $args Method parameters.
  	 * @return array
***************
*** 829,835 ****
  
  		do_action( 'xmlrpc_call', 'wp.getKeywords' );
  
! 		$tags = array( );
  
  		if ( $all_tags = get_tags() ) {
  			foreach( (array) $all_tags as $tag ) {
--- 2228,2234 ----
  
  		do_action( 'xmlrpc_call', 'wp.getKeywords' );
  
! 		$tags = array();
  
  		if ( $all_tags = get_tags() ) {
  			foreach( (array) $all_tags as $tag ) {
***************
*** 903,909 ****
  			return(new IXR_Error(500, __('Sorry, the new category failed.')));
  		}
  
! 		return($cat_id);
  	}
  
  	/**
--- 2302,2310 ----
  			return(new IXR_Error(500, __('Sorry, the new category failed.')));
  		}
  
! 		do_action( 'xmlrpc_call_success_wp_newCategory', $cat_id, $args );
! 
! 		return $cat_id;
  	}
  
  	/**
***************
*** 930,936 ****
  		if ( !current_user_can('manage_categories') )
  			return new IXR_Error( 401, __( 'Sorry, you do not have the right to delete a category.' ) );
  
! 		return wp_delete_term( $category_id, 'category' );
  	}
  
  	/**
--- 2331,2342 ----
  		if ( !current_user_can('manage_categories') )
  			return new IXR_Error( 401, __( 'Sorry, you do not have the right to delete a category.' ) );
  
! 		$status = wp_delete_term( $category_id, 'category' );
! 
! 		if( true == $status )
! 			do_action( 'xmlrpc_call_success_wp_deleteCategory', $category_id, $args );
! 
! 		return $status;
  	}
  
  	/**
***************
*** 997,1035 ****
  		if ( ! $comment = get_comment($comment_id) )
  			return new IXR_Error( 404, __( 'Invalid comment ID.' ) );
  
! 		// Format page date.
! 		$comment_date = mysql2date('Ymd\TH:i:s', $comment->comment_date, false);
! 		$comment_date_gmt = mysql2date('Ymd\TH:i:s', $comment->comment_date_gmt, false);
! 
! 		if ( '0' == $comment->comment_approved )
! 			$comment_status = 'hold';
! 		else if ( 'spam' == $comment->comment_approved )
! 			$comment_status = 'spam';
! 		else if ( '1' == $comment->comment_approved )
! 			$comment_status = 'approve';
! 		else
! 			$comment_status = $comment->comment_approved;
! 
! 		$link = get_comment_link($comment);
! 
! 		$comment_struct = array(
! 			'date_created_gmt'		=> new IXR_Date($comment_date_gmt),
! 			'user_id'				=> $comment->user_id,
! 			'comment_id'			=> $comment->comment_ID,
! 			'parent'				=> $comment->comment_parent,
! 			'status'				=> $comment_status,
! 			'content'				=> $comment->comment_content,
! 			'link'					=> $link,
! 			'post_id'				=> $comment->comment_post_ID,
! 			'post_title'			=> get_the_title($comment->comment_post_ID),
! 			'author'				=> $comment->comment_author,
! 			'author_url'			=> $comment->comment_author_url,
! 			'author_email'			=> $comment->comment_author_email,
! 			'author_ip'				=> $comment->comment_author_IP,
! 			'type'					=> $comment->comment_type,
! 		);
! 
! 		return $comment_struct;
  	}
  
  	/**
--- 2403,2409 ----
  		if ( ! $comment = get_comment($comment_id) )
  			return new IXR_Error( 404, __( 'Invalid comment ID.' ) );
  
! 		return $this->_prepare_comment( $comment );
  	}
  
  	/**
***************
*** 1052,1064 ****
  	 * @return array. Contains a collection of comments. See {@link wp_xmlrpc_server::wp_getComment()} for a description of each item contents
  	 */
  	function wp_getComments($args) {
- 		$raw_args = $args;
  		$this->escape($args);
  
  		$blog_id	= (int) $args[0];
  		$username	= $args[1];
  		$password	= $args[2];
! 		$struct		= $args[3];
  
  		if ( !$user = $this->login($username, $password) )
  			return $this->error;
--- 2426,2437 ----
  	 * @return array. Contains a collection of comments. See {@link wp_xmlrpc_server::wp_getComment()} for a description of each item contents
  	 */
  	function wp_getComments($args) {
  		$this->escape($args);
  
  		$blog_id	= (int) $args[0];
  		$username	= $args[1];
  		$password	= $args[2];
! 		$struct		= isset( $args[3] ) ? $args[3] : array();
  
  		if ( !$user = $this->login($username, $password) )
  			return $this->error;
***************
*** 1086,1104 ****
  			$number = absint($struct['number']);
  
  		$comments = get_comments( array('status' => $status, 'post_id' => $post_id, 'offset' => $offset, 'number' => $number ) );
- 		$num_comments = count($comments);
- 
- 		if ( ! $num_comments )
- 			return array();
  
  		$comments_struct = array();
  
!     // FIXME: we already have the comments, why query them again?
! 		for ( $i = 0; $i < $num_comments; $i++ ) {
! 			$comment = wp_xmlrpc_server::wp_getComment(array(
! 				$raw_args[0], $raw_args[1], $raw_args[2], $comments[$i]->comment_ID,
! 			));
! 			$comments_struct[] = $comment;
  		}
  
  		return $comments_struct;
--- 2459,2469 ----
  			$number = absint($struct['number']);
  
  		$comments = get_comments( array('status' => $status, 'post_id' => $post_id, 'offset' => $offset, 'number' => $number ) );
  
  		$comments_struct = array();
  
! 		foreach ( $comments as $comment ) {
! 			$comments_struct[] = $this->_prepare_comment( $comment );
  		}
  
  		return $comments_struct;
***************
*** 1142,1148 ****
  
  		do_action('xmlrpc_call', 'wp.deleteComment');
  
! 		return wp_delete_comment($comment_ID);
  	}
  
  	/**
--- 2507,2518 ----
  
  		do_action('xmlrpc_call', 'wp.deleteComment');
  
! 		$status = wp_delete_comment( $comment_ID );
! 
! 		if( true == $status )
! 			do_action( 'xmlrpc_call_success_wp_deleteComment', $comment_ID, $args );
! 
! 		return $status;
  	}
  
  	/**
***************
*** 1203,1209 ****
  
  		// Do some timestamp voodoo
  		if ( !empty( $content_struct['date_created_gmt'] ) ) {
! 			$dateCreated = str_replace( 'Z', '', $content_struct['date_created_gmt']->getIso() ) . 'Z'; // We know this is supposed to be GMT, so we're going to slap that Z on there by force
  			$comment_date = get_date_from_gmt(iso8601_to_datetime($dateCreated));
  			$comment_date_gmt = iso8601_to_datetime($dateCreated, 'GMT');
  		}
--- 2573,2580 ----
  
  		// Do some timestamp voodoo
  		if ( !empty( $content_struct['date_created_gmt'] ) ) {
! 			// We know this is supposed to be GMT, so we're going to slap that Z on there by force
! 			$dateCreated = rtrim( $content_struct['date_created_gmt']->getIso(), 'Z' ) . 'Z';
  			$comment_date = get_date_from_gmt(iso8601_to_datetime($dateCreated));
  			$comment_date_gmt = iso8601_to_datetime($dateCreated, 'GMT');
  		}
***************
*** 1230,1235 ****
--- 2601,2608 ----
  		if ( !$result )
  			return new IXR_Error(500, __('Sorry, the comment could not be edited. Something wrong happened.'));
  
+ 		do_action( 'xmlrpc_call_success_wp_editComment', $comment_ID, $args );
+ 
  		return true;
  	}
  
***************
*** 1313,1319 ****
  
  		do_action('xmlrpc_call', 'wp.newComment');
  
! 		return wp_new_comment($comment);
  	}
  
  	/**
--- 2686,2696 ----
  
  		do_action('xmlrpc_call', 'wp.newComment');
  
! 		$comment_ID = wp_new_comment( $comment );
! 
! 		do_action( 'xmlrpc_call_success_wp_newComment', $comment_ID, $args );
! 
! 		return $comment_ID;
  	}
  
  	/**
***************
*** 1339,1345 ****
  
  		do_action('xmlrpc_call', 'wp.getCommentStatusList');
  
! 		return get_comment_statuses( );
  	}
  
  	/**
--- 2716,2722 ----
  
  		do_action('xmlrpc_call', 'wp.getCommentStatusList');
  
! 		return get_comment_statuses();
  	}
  
  	/**
***************
*** 1398,1404 ****
  
  		do_action('xmlrpc_call', 'wp.getPostStatusList');
  
! 		return get_post_statuses( );
  	}
  
  	/**
--- 2775,2781 ----
  
  		do_action('xmlrpc_call', 'wp.getPostStatusList');
  
! 		return get_post_statuses();
  	}
  
  	/**
***************
*** 1424,1430 ****
  
  		do_action('xmlrpc_call', 'wp.getPageStatusList');
  
! 		return get_page_statuses( );
  	}
  
  	/**
--- 2801,2807 ----
  
  		do_action('xmlrpc_call', 'wp.getPageStatusList');
  
! 		return get_page_statuses();
  	}
  
  	/**
***************
*** 1448,1454 ****
  		if ( !current_user_can( 'edit_pages' ) )
  			return new IXR_Error( 403, __( 'You are not allowed access to details about this site.' ) );
  
! 		$templates = get_page_templates( );
  		$templates['Default'] = 'default';
  
  		return $templates;
--- 2825,2831 ----
  		if ( !current_user_can( 'edit_pages' ) )
  			return new IXR_Error( 403, __( 'You are not allowed access to details about this site.' ) );
  
! 		$templates = get_page_templates();
  		$templates['Default'] = 'default';
  
  		return $templates;
***************
*** 1489,1495 ****
  	 * @return array
  	 */
  	function _getOptions($options) {
! 		$data = array( );
  		foreach ( $options as $option ) {
  			if ( array_key_exists( $option, $this->blog_options ) ) {
  				$data[$option] = $this->blog_options[$option];
--- 2866,2872 ----
  	 * @return array
  	 */
  	function _getOptions($options) {
! 		$data = array();
  		foreach ( $options as $option ) {
  			if ( array_key_exists( $option, $this->blog_options ) ) {
  				$data[$option] = $this->blog_options[$option];
***************
*** 1573,1604 ****
  			return $this->error;
  
  		if ( !current_user_can( 'upload_files' ) )
! 			return new IXR_Error( 403, __( 'You are not allowed to upload files to this site.' ) );
  
  		do_action('xmlrpc_call', 'wp.getMediaItem');
  
  		if ( ! $attachment = get_post($attachment_id) )
  			return new IXR_Error( 404, __( 'Invalid attachment ID.' ) );
  
! 		// Format page date.
! 		$attachment_date = mysql2date('Ymd\TH:i:s', $attachment->post_date, false);
! 		$attachment_date_gmt = mysql2date('Ymd\TH:i:s', $attachment->post_date_gmt, false);
! 
! 		$link = wp_get_attachment_url($attachment->ID);
! 		$thumbnail_link = wp_get_attachment_thumb_url($attachment->ID);
! 
! 		$attachment_struct = array(
! 			'date_created_gmt'		=> new IXR_Date($attachment_date_gmt),
! 			'parent'				=> $attachment->post_parent,
! 			'link'					=> $link,
! 			'thumbnail'				=> $thumbnail_link,
! 			'title'					=> $attachment->post_title,
! 			'caption'				=> $attachment->post_excerpt,
! 			'description'			=> $attachment->post_content,
! 			'metadata'				=> wp_get_attachment_metadata($attachment->ID),
! 		);
! 
! 		return $attachment_struct;
  	}
  
  	/**
--- 2950,2963 ----
  			return $this->error;
  
  		if ( !current_user_can( 'upload_files' ) )
! 			return new IXR_Error( 403, __( 'You do not have permission to upload files.' ) );
  
  		do_action('xmlrpc_call', 'wp.getMediaItem');
  
  		if ( ! $attachment = get_post($attachment_id) )
  			return new IXR_Error( 404, __( 'Invalid attachment ID.' ) );
  
! 		return $this->_prepare_media_item( $attachment );
  	}
  
  	/**
***************
*** 1625,1631 ****
  	 * @return array. Contains a collection of media items. See {@link wp_xmlrpc_server::wp_getMediaItem()} for a description of each item contents
  	 */
  	function wp_getMediaLibrary($args) {
- 		$raw_args = $args;
  		$this->escape($args);
  
  		$blog_id	= (int) $args[0];
--- 2984,2989 ----
***************
*** 1637,1643 ****
  			return $this->error;
  
  		if ( !current_user_can( 'upload_files' ) )
! 			return new IXR_Error( 401, __( 'Sorry, you cannot upload files.' ) );
  
  		do_action('xmlrpc_call', 'wp.getMediaLibrary');
  
--- 2995,3001 ----
  			return $this->error;
  
  		if ( !current_user_can( 'upload_files' ) )
! 			return new IXR_Error( 401, __( 'You do not have permission to upload files.' ) );
  
  		do_action('xmlrpc_call', 'wp.getMediaLibrary');
  
***************
*** 1647,1661 ****
  		$number = ( isset($struct['number']) ) ? absint($struct['number']) : -1 ;
  
  		$attachments = get_posts( array('post_type' => 'attachment', 'post_parent' => $parent_id, 'offset' => $offset, 'numberposts' => $number, 'post_mime_type' => $mime_type ) );
- 		$num_attachments = count($attachments);
- 
- 		if ( ! $num_attachments )
- 			return array();
  
  		$attachments_struct = array();
  
  		foreach ($attachments as $attachment )
! 			$attachments_struct[] = $this->wp_getMediaItem( array( $raw_args[0], $raw_args[1], $raw_args[2], $attachment->ID ) );
  
  		return $attachments_struct;
  	}
--- 3005,3015 ----
  		$number = ( isset($struct['number']) ) ? absint($struct['number']) : -1 ;
  
  		$attachments = get_posts( array('post_type' => 'attachment', 'post_parent' => $parent_id, 'offset' => $offset, 'numberposts' => $number, 'post_mime_type' => $mime_type ) );
  
  		$attachments_struct = array();
  
  		foreach ($attachments as $attachment )
! 			$attachments_struct[] = $this->_prepare_media_item( $attachment );
  
  		return $attachments_struct;
  	}
***************
*** 1681,1686 ****
--- 3035,3043 ----
  		if ( !$user = $this->login( $username, $password ) )
  			return $this->error;
  
+ 		if ( !current_user_can( 'edit_posts' ) )
+ 			return new IXR_Error( 403, __( 'You are not allowed access to details about this site.' ) );
+ 
  		do_action( 'xmlrpc_call', 'wp.getPostFormats' );
  
  		$formats = get_post_format_strings();
***************
*** 1702,1707 ****
--- 3059,3168 ----
  		return $formats;
  	}
  
+ 	/**
+ 	 * Retrieves a post type
+ 	 *
+ 	 * @since 3.4.0
+ 	 *
+ 	 * @uses get_post_type_object()
+ 	 * @param array $args Method parameters. Contains:
+ 	 *  - int     $blog_id
+ 	 *  - string  $username
+ 	 *  - string  $password
+ 	 *  - string  $post_type_name
+ 	 *  - array   $fields
+ 	 * @return array contains:
+ 	 *  - 'labels'
+ 	 *  - 'description'
+ 	 *  - 'capability_type'
+ 	 *  - 'cap'
+ 	 *  - 'map_meta_cap'
+ 	 *  - 'hierarchical'
+ 	 *  - 'menu_position'
+ 	 *  - 'taxonomies'
+ 	 *  - 'supports'
+ 	 */
+ 	function wp_getPostType( $args ) {
+ 		if ( ! $this->minimum_args( $args, 4 ) )
+ 			return $this->error;
+ 
+ 		$this->escape( $args );
+ 
+ 		$blog_id        = (int) $args[0];
+ 		$username       = $args[1];
+ 		$password       = $args[2];
+ 		$post_type_name = $args[3];
+ 
+ 		if ( isset( $args[4] ) )
+ 			$fields = $args[4];
+ 		else
+ 			$fields = apply_filters( 'xmlrpc_default_posttype_fields', array( 'labels', 'cap', 'taxonomies' ), 'wp.getPostType' );
+ 
+ 		if ( !$user = $this->login( $username, $password ) )
+ 			return $this->error;
+ 
+ 		do_action( 'xmlrpc_call', 'wp.getPostType' );
+ 
+ 		if( ! post_type_exists( $post_type_name ) )
+ 			return new IXR_Error( 403, __( 'Invalid post type' ) );
+ 
+ 		$post_type = get_post_type_object( $post_type_name );
+ 
+ 		if( ! current_user_can( $post_type->cap->edit_posts ) )
+ 			return new IXR_Error( 401, __( 'Sorry, you are not allowed to edit this post type.' ) );
+ 
+ 		return $this->_prepare_post_type( $post_type, $fields );
+ 	}
+ 
+ 	/**
+ 	 * Retrieves a post types
+ 	 *
+ 	 * @since 3.4.0
+ 	 *
+ 	 * @uses get_post_types()
+ 	 * @param array $args Method parameters. Contains:
+ 	 *  - int     $blog_id
+ 	 *  - string  $username
+ 	 *  - string  $password
+ 	 *  - array   $filter
+ 	 *  - array   $fields
+ 	 * @return array
+ 	 */
+ 	function wp_getPostTypes( $args ) {
+ 		if ( ! $this->minimum_args( $args, 3 ) )
+ 			return $this->error;
+ 
+ 		$this->escape( $args );
+ 
+ 		$blog_id            = (int) $args[0];
+ 		$username           = $args[1];
+ 		$password           = $args[2];
+ 		$filter             = isset( $args[3] ) ? $args[3] : array( 'public' => true );
+ 
+ 		if ( isset( $args[4] ) )
+ 			$fields = $args[4];
+ 		else
+ 			$fields = apply_filters( 'xmlrpc_default_posttype_fields', array( 'labels', 'cap', 'taxonomies' ), 'wp.getPostTypes' );
+ 
+ 		if ( ! $user = $this->login( $username, $password ) )
+ 			return $this->error;
+ 
+ 		do_action( 'xmlrpc_call', 'wp.getPostTypes' );
+ 
+ 		$post_types = get_post_types( $filter, 'objects' );
+ 
+ 		$struct = array();
+ 
+ 		foreach( $post_types as $post_type ) {
+ 			if( ! current_user_can( $post_type->cap->edit_posts ) )
+ 				continue;
+ 
+ 			$struct[$post_type->name] = $this->_prepare_post_type( $post_type, $fields );
+ 		}
+ 
+ 		return $struct;
+ 	}
+ 
  	/* Blogger API functions.
  	 * specs on http://plant.blogger.com/api and http://groups.yahoo.com/group/bloggerDev/
  	 */
***************
*** 1827,1839 ****
  		if ( !$user = $this->login($username, $password) )
  			return $this->error;
  
  		if ( !current_user_can( 'edit_post', $post_ID ) )
  			return new IXR_Error( 401, __( 'Sorry, you cannot edit this post.' ) );
  
  		do_action('xmlrpc_call', 'blogger.getPost');
  
- 		$post_data = wp_get_single_post($post_ID, ARRAY_A);
- 
  		$categories = implode(',', wp_get_post_categories($post_ID));
  
  		$content  = '<title>'.stripslashes($post_data['post_title']).'</title>';
--- 3288,3302 ----
  		if ( !$user = $this->login($username, $password) )
  			return $this->error;
  
+ 		$post_data = wp_get_single_post($post_ID, ARRAY_A);
+ 		if ( ! $post_data )
+ 			return new IXR_Error( 404, __( 'Invalid post ID.' ) );
+ 
  		if ( !current_user_can( 'edit_post', $post_ID ) )
  			return new IXR_Error( 401, __( 'Sorry, you cannot edit this post.' ) );
  
  		do_action('xmlrpc_call', 'blogger.getPost');
  
  		$categories = implode(',', wp_get_post_categories($post_ID));
  
  		$content  = '<title>'.stripslashes($post_data['post_title']).'</title>';
***************
*** 1842,1848 ****
  
  		$struct = array(
  			'userid'    => $post_data['post_author'],
! 			'dateCreated' => new IXR_Date(mysql2date('Ymd\TH:i:s', $post_data['post_date'], false)),
  			'content'     => $content,
  			'postid'  => (string) $post_data['ID']
  		);
--- 3305,3311 ----
  
  		$struct = array(
  			'userid'    => $post_data['post_author'],
! 			'dateCreated' => $this->_convert_date( $post_data['post_date'] ),
  			'content'     => $content,
  			'postid'  => (string) $post_data['ID']
  		);
***************
*** 1887,1893 ****
  			if ( !current_user_can( 'edit_post', $entry['ID'] ) )
  				continue;
  
! 			$post_date = mysql2date('Ymd\TH:i:s', $entry['post_date'], false);
  			$categories = implode(',', wp_get_post_categories($entry['ID']));
  
  			$content  = '<title>'.stripslashes($entry['post_title']).'</title>';
--- 3350,3356 ----
  			if ( !current_user_can( 'edit_post', $entry['ID'] ) )
  				continue;
  
! 			$post_date  = $this->_convert_date( $entry['post_date'] );
  			$categories = implode(',', wp_get_post_categories($entry['ID']));
  
  			$content  = '<title>'.stripslashes($entry['post_title']).'</title>';
***************
*** 1896,1902 ****
  
  			$struct[] = array(
  				'userid' => $entry['post_author'],
! 				'dateCreated' => new IXR_Date($post_date),
  				'content' => $content,
  				'postid' => (string) $entry['ID'],
  			);
--- 3359,3365 ----
  
  			$struct[] = array(
  				'userid' => $entry['post_author'],
! 				'dateCreated' => $post_date,
  				'content' => $content,
  				'postid' => (string) $entry['ID'],
  			);
***************
*** 1934,1940 ****
  		do_action('xmlrpc_call', 'blogger.getTemplate');
  
  		if ( !current_user_can('edit_themes') )
! 			return new IXR_Error(401, __('Sorry, this user can not edit the template.'));
  
  		/* warning: here we make the assumption that the blog's URL is on the same server */
  		$filename = get_option('home') . '/';
--- 3397,3403 ----
  		do_action('xmlrpc_call', 'blogger.getTemplate');
  
  		if ( !current_user_can('edit_themes') )
! 			return new IXR_Error(401, __('Sorry, this user cannot edit the template.'));
  
  		/* warning: here we make the assumption that the blog's URL is on the same server */
  		$filename = get_option('home') . '/';
***************
*** 1945,1951 ****
  		fclose($f);
  
  		/* so it is actually editable with a windows/mac client */
! 		// FIXME: (or delete me) do we really want to cater to bad clients at the expense of good ones by BEEPing up their line breaks? commented.     $content = str_replace("\n", "\r\n", $content);
  
  		return $content;
  	}
--- 3408,3414 ----
  		fclose($f);
  
  		/* so it is actually editable with a windows/mac client */
! 		// FIXME: (or delete me) do we really want to cater to bad clients at the expense of good ones by BEEPing up their line breaks? commented. $content = str_replace("\n", "\r\n", $content);
  
  		return $content;
  	}
***************
*** 2039,2045 ****
  
  		$this->attach_uploads( $post_ID, $post_content );
  
! 		logIO('O', "Posted ! ID: $post_ID");
  
  		return $post_ID;
  	}
--- 3502,3508 ----
  
  		$this->attach_uploads( $post_ID, $post_content );
  
! 		do_action( 'xmlrpc_call_success_blogger_newPost', $post_ID, $args );
  
  		return $post_ID;
  	}
***************
*** 2095,2100 ****
--- 3558,3565 ----
  
  		$this->attach_uploads( $ID, $post_content );
  
+ 		do_action( 'xmlrpc_call_success_blogger_editPost', $post_ID, $args );
+ 
  		return true;
  	}
  
***************
*** 2132,2137 ****
--- 3597,3604 ----
  		if ( !$result )
  			return new IXR_Error(500, __('For some strange yet very annoying reason, this post could not be deleted.'));
  
+ 		do_action( 'xmlrpc_call_success_blogger_deletePost', $post_ID, $args );
+ 
  		return true;
  	}
  
***************
*** 2162,2167 ****
--- 3629,3635 ----
  	 *  - mt_allow_pings - can be 'open' or 'closed'
  	 *  - date_created_gmt
  	 *  - dateCreated
+ 	 *  - wp_post_thumbnail
  	 *
  	 * @since 1.5.0
  	 *
***************
*** 2176,2182 ****
  	function mw_newPost($args) {
  		$this->escape($args);
  
! 		$blog_ID     = (int) $args[0]; // we will support this in the near future
  		$username  = $args[1];
  		$password   = $args[2];
  		$content_struct = $args[3];
--- 3644,3650 ----
  	function mw_newPost($args) {
  		$this->escape($args);
  
! 		$blog_ID     = (int) $args[0];
  		$username  = $args[1];
  		$password   = $args[2];
  		$content_struct = $args[3];
***************
*** 2192,2198 ****
  			if ( $content_struct['post_type'] == 'page' ) {
  				if ( $publish )
  					$cap  = 'publish_pages';
! 				elseif ('publish' == $content_struct['page_status'])
  					$cap  = 'publish_pages';
  				else
  					$cap = 'edit_pages';
--- 3660,3666 ----
  			if ( $content_struct['post_type'] == 'page' ) {
  				if ( $publish )
  					$cap  = 'publish_pages';
! 				elseif ( isset( $content_struct['page_status'] ) && 'publish' == $content_struct['page_status'] )
  					$cap  = 'publish_pages';
  				else
  					$cap = 'edit_pages';
***************
*** 2203,2209 ****
  			} elseif ( $content_struct['post_type'] == 'post' ) {
  				if ( $publish )
  					$cap  = 'publish_posts';
! 				elseif ('publish' == $content_struct['post_status'])
  					$cap  = 'publish_posts';
  				else
  					$cap = 'edit_posts';
--- 3671,3677 ----
  			} elseif ( $content_struct['post_type'] == 'post' ) {
  				if ( $publish )
  					$cap  = 'publish_posts';
! 				elseif ( isset( $content_struct['post_status'] ) && 'publish' == $content_struct['post_status'] )
  					$cap  = 'publish_posts';
  				else
  					$cap = 'edit_posts';
***************
*** 2211,2222 ****
  				$post_type = 'post';
  			} else {
  				// No other post_type values are allowed here
! 				return new IXR_Error( 401, __( 'Invalid post type.' ) );
  			}
  		} else {
  			if ( $publish )
  				$cap  = 'publish_posts';
! 			elseif ('publish' == $content_struct['post_status'])
  				$cap  = 'publish_posts';
  			else
  				$cap = 'edit_posts';
--- 3679,3690 ----
  				$post_type = 'post';
  			} else {
  				// No other post_type values are allowed here
! 				return new IXR_Error( 401, __( 'Invalid post type' ) );
  			}
  		} else {
  			if ( $publish )
  				$cap  = 'publish_posts';
! 			elseif ( isset( $content_struct['post_status'] ) && 'publish' == $content_struct['post_status'])
  				$cap  = 'publish_posts';
  			else
  				$cap = 'edit_posts';
***************
*** 2267,2275 ****
  						return(new IXR_Error(401, __('You are not allowed to create pages as this user')));
  					break;
  				default:
! 					return(new IXR_Error(401, __('Invalid post type.')));
  					break;
  			}
  			$post_author = $content_struct['wp_author_id'];
  		}
  
--- 3735,3746 ----
  						return(new IXR_Error(401, __('You are not allowed to create pages as this user')));
  					break;
  				default:
! 					return(new IXR_Error(401, __('Invalid post type')));
  					break;
  			}
+ 			$author = get_userdata( $content_struct['wp_author_id'] );
+ 			if ( ! $author )
+ 				return new IXR_Error( 404, __( 'Invalid author ID.' ) );
  			$post_author = $content_struct['wp_author_id'];
  		}
  
***************
*** 2370,2376 ****
  
  		// Do some timestamp voodoo
  		if ( !empty( $content_struct['date_created_gmt'] ) )
! 			$dateCreated = str_replace( 'Z', '', $content_struct['date_created_gmt']->getIso() ) . 'Z'; // We know this is supposed to be GMT, so we're going to slap that Z on there by force
  		elseif ( !empty( $content_struct['dateCreated']) )
  			$dateCreated = $content_struct['dateCreated']->getIso();
  
--- 3841,3848 ----
  
  		// Do some timestamp voodoo
  		if ( !empty( $content_struct['date_created_gmt'] ) )
! 			// We know this is supposed to be GMT, so we're going to slap that Z on there by force
! 			$dateCreated = rtrim( $content_struct['date_created_gmt']->getIso(), 'Z' ) . 'Z';
  		elseif ( !empty( $content_struct['dateCreated']) )
  			$dateCreated = $content_struct['dateCreated']->getIso();
  
